#include <Keypad.h>
#include "Keyboard.h"
#define speaker       2 // Speaker
const byte ROWS = 6; // rows
const byte COLS = 6; // columns
byte colPins[COLS] = {31, 30, 28, 0, 1,8}; //pa13-d38,connect to the row pinouts of the keypad
byte rowPins[ROWS] = {3, 4, 5, 6, 7, 27}; //pb22-d30,pb23-d31,pa28-d27 connect to the column pinouts of the keypad
//define the symbols on the buttons of the keypads
char directKeys[ROWS][COLS] = {
  {' ', '.', 'm', 'n', 'b',KEY_LEFT_ARROW},
  {KEY_RETURN, 'l', 'k', 'j', 'h',KEY_UP_ARROW},
  {'p', 'o', 'i', 'u', 'y',KEY_DOWN_ARROW},
  {1, 'z', 'x', 'c', 'v',KEY_RIGHT_ARROW},
  {'a', 's', 'd', 'f', 'g',KEY_ESC},
  {'q', 'w', 'e', 'r', 't',KEY_BACKSPACE}  
};
char shiftKeys[ROWS][COLS] = {
  {' ', ',', 'M', 'N', 'B',KEY_HOME},
  {KEY_RETURN, 'L', 'K', 'J', 'H',KEY_PAGE_UP},
  {'P', 'O', 'I', 'U', 'Y',KEY_PAGE_DOWN},
  {1, 'Z', 'X', 'C', 'V',KEY_END},
  {'A', 'S', 'D', 'F', 'G',KEY_TAB},
  {'Q', 'W', 'E', 'R', 'T',KEY_DELETE}   
};
//char shiftKeys[ROWS][COLS] = {
//  {' ', ',', 'M', 'N', 'B',KEY_LEFT_ARROW},
//  {KEY_RETURN, 'L', 'K', 'J', 'H',KEY_UP_ARROW},
//  {'P', 'O', 'I', 'U', 'Y',KEY_DOWN_ARROW},
//  {1, 'Z', 'X', 'C', 'V',KEY_RIGHT_ARROW},
//  {'A', 'S', 'D', 'F', 'G',KEY_ESC},
//  {'Q', 'W', 'E', 'R', 'T',KEY_BACKSPACE}   
//};

char fnKeys[ROWS][COLS] = {
  {':', ';', '>', '<', '""','['},
  {'\\', '-', '*', '&', '+','}'},
  {'0', '9', '8', '7', '6','{'},
  {1, '(', ')', '?', '/',']'},
  {'!', '@', '#', '$', '%',KEY_F11},
  {'1', '2', '3', '4', '5',KEY_F10}  
};

//char capsKeys[ROWS][COLS] = {
//  {' ', ',', 'M', 'N', 'B',KEY_LEFT_ARROW},
//  {KEY_RETURN, 'L', 'K', 'J', 'H',KEY_UP_ARROW},
//  {'P', 'O', 'I', 'U', 'Y',KEY_DOWN_ARROW},
//  {1, 'Z', 'X', 'C', 'V',KEY_RIGHT_ARROW},
//  {'A', 'S', 'D', 'F', 'G',KEY_ESC},
//  {'Q', 'W', 'E', 'R', 'T',KEY_BACKSPACE}
//};
//char directKeys[ROWS][COLS] = {
//  {'`', '1', '2', '3', '4', '5', '6', 1},
//  {KEY_ESC, 'q', 'w', 'e', 'r', 't', 'y', ';'},
//  {'[', 'a', 's', 'd', 'f', 'g', 'h', 39}, //39 is '
//  {']', 'z', 'x', 'c', 'v', 'b', 'n', '-'},
//  {'7', '8', '9', '0', KEY_DOWN_ARROW, KEY_RIGHT_ARROW, KEY_LEFT_ARROW, KEY_UP_ARROW},
//  {'u', 'i', 'o', 'p', '.', '/', ' ', '='},
//  {'j', 'k', 'l', KEY_BACKSPACE, 'm', 92, KEY_RETURN, ','}
//};
//char shiftKeys[ROWS][COLS] = {
//  {'~', '!', '@', '#', '$', '%', '^', 1},
//  {KEY_TAB, 'Q', 'W', 'E', 'R', 'T', 'Y', ';'},
//  {'{', 'A', 'S', 'D', 'F', 'G', 'H', 34}, //34 is "
//  {'}', 'Z', 'X', 'C', 'V', 'B', 'N', '_'},
//  {'&', '*', '(', ')', KEY_PAGE_DOWN, KEY_END, KEY_HOME, KEY_PAGE_UP},
//  {'U', 'I', 'O', 'P', '>', '?', ' ', '+'},
//  {'J', 'K', 'L', KEY_DELETE, 'M', 92, KEY_RETURN, ','}
//};
//char fnKeys[ROWS][COLS] = {
//  {'`', KEY_F1, KEY_F2, KEY_F3, KEY_F4, KEY_F5, KEY_F6, 1},
//  {KEY_ESC, 'q', 'w', 'e', 'r', 't', 'y', ';'},
//  {'[', 'a', 's', 'd', 'f', 'g', 'h', 39}, //39 is '
//  {']', 'z', 'x', 'c', 'v', 'b', 'n', '-'},
//  {KEY_F7, KEY_F8, KEY_F9, KEY_F10, KEY_DOWN_ARROW, KEY_RIGHT_ARROW, KEY_LEFT_ARROW, KEY_UP_ARROW},
//  {'u', 'i', 'o', 'p', '.', '/', ' ', '='},
//  {'j', 'k', 'l', KEY_BACKSPACE, 'm', 92, KEY_RETURN, ','}
//};
//char capsKeys[ROWS][COLS] = {
//  {'`', '1', '2', '3', '4', '5', '6', 1},
//  {KEY_ESC, 'Q', 'W', 'E', 'R', 'T', 'Y', ';'},
//  {'[', 'A', 'S', 'D', 'F', 'G', 'H', 39}, //39 is '
//  {']', 'Z', 'X', 'C', 'V', 'B', 'N', '-'},
//  {'7', '8', '9', '0', KEY_DOWN_ARROW, KEY_RIGHT_ARROW, KEY_LEFT_ARROW, KEY_UP_ARROW},
//  {'U', 'I', 'O', 'P', '.', '/', ' ', '='},
//  {'J', 'K', 'L', KEY_BACKSPACE, 'M', 92, KEY_INSERT, ','}
//};

// Create 3 new key layouts
Keypad directLayout( makeKeymap(directKeys), rowPins, colPins, sizeof(rowPins), sizeof(colPins) );
Keypad shiftLayout( makeKeymap(shiftKeys), rowPins, colPins, sizeof(rowPins), sizeof(colPins) );
Keypad fnLayout( makeKeymap(fnKeys), rowPins, colPins, sizeof(rowPins), sizeof(colPins) );
//Keypad capsLayout( makeKeymap(capsKeys), rowPins, colPins, sizeof(rowPins), sizeof(colPins) );

byte Layout = 0;
char Key = 0;
byte State = 0;
const bool StartupDance = true;

#define ledaA 10
#define ledFn 11
void setup() {
  Keyboard.begin();
  pinMode(ledaA, OUTPUT);
  pinMode(ledFn, OUTPUT);
  digitalWrite(ledaA, LOW);
  digitalWrite(ledFn, LOW);
  pinMode(speaker, OUTPUT);
  digitalWrite(speaker, LOW);
  playTone( 10, 1000); 
  directLayout.begin( makeKeymap(directKeys) );
  shiftLayout.begin( makeKeymap(shiftKeys) );
  fnLayout.begin( makeKeymap(fnKeys) );
//  capsLayout.begin( makeKeymap(capsKeys) );

  // Startup dance!
  if (StartupDance) {
    for ( int i = 0; i < 3; i++ ) {
      digitalWrite(ledaA, HIGH);
      digitalWrite(ledFn, LOW);
      delay(80);
      digitalWrite(ledaA, LOW);
      digitalWrite(ledFn, HIGH);
      delay(80);
    }
  }

}

void loop() {
  getKey();
}


// 
// We simply replicate the functions within the Keyboard
// library by mapping them to the events provided by the
// Keypad library. When we press a key, we trigger the .press()
// function on it; when we release a key, we trigger the
// .releaseAll() function. We don't need to do anything special
// for the hold State for regular keys, but we do use the hold state
// to trigger activation of FN mode 2 (Ctrl).
//
void respondToKey(char key, byte state) {
  switch (state) {
    case PRESSED:
     
      if (key == 1) {
        Layout++;
        key = 0;
        delay(400);
      } else {
        if (Layout == 3) {
        if ((key == KEY_RIGHT_ARROW)||(key == KEY_LEFT_ARROW)||(key == KEY_UP_ARROW)||(key == KEY_DOWN_ARROW)){
         Keyboard.press(KEY_LEFT_SHIFT);
        }
          else
          {
          Keyboard.press(KEY_LEFT_CTRL);           
          }
        }
        Keyboard.press(key);
//        if ((Layout == 1)||(Layout == 2)) {
//        Layout = 0;
// //       State = 0;         
// //     Keyboard.releaseAll();
//       }
      }
      break;
    case HOLD:
      break;
    case RELEASED:
//        if(key != 1){
//        if ((Layout == 1)||(Layout == 2)) {
//        Layout = 0;         
//        }
//
//        if (Layout ==3)
//        {
//        if ((key == KEY_RIGHT_ARROW)||(key == KEY_LEFT_ARROW)||(key == KEY_UP_ARROW)||(key == KEY_DOWN_ARROW)){
//        Layout = 0;  
//        }
//       }
//        }
      Keyboard.releaseAll();
      break;
  }
}


void getKey() {
  switch (Layout) {
    case 0:
      digitalWrite(ledaA, LOW);
      digitalWrite(ledFn, LOW);
      Key = directLayout.getKey();
      State = directLayout.getState();
      break;
    case 1:
      digitalWrite(ledaA, HIGH);
      digitalWrite(ledFn, LOW);
      Key = shiftLayout.getKey();
      State = shiftLayout.getState();
      break;
    case 2:
      digitalWrite(ledaA, LOW);
      digitalWrite(ledFn, HIGH);
      Key = fnLayout.getKey();
      State = fnLayout.getState();
      break;
    case 3:
      digitalWrite(ledaA, HIGH);
      digitalWrite(ledFn, HIGH);
      Key = directLayout.getKey();
      State = directLayout.getState();
      break;
    default:
      Layout = 0;
      State = 0;
  }

  respondToKey(Key, State);
}


//void loop() {
//  switch (Layout) {
//    case 0:
//      digitalWrite(ledaA, LOW);
//      digitalWrite(ledFn, LOW);
//      Key = directLayout.getKey();
//      break;
//
//    case 1:
//      digitalWrite(ledaA, HIGH);
//      digitalWrite(ledFn, LOW);
//      Key = shiftLayout.getKey();
//      if (Key >= 2) {
//        Layout = 0;
//      }
//      break;
//
//    case 2:
//      digitalWrite(ledaA, LOW); 
//      digitalWrite(ledFn, HIGH);
//      Key = fnLayout.getKey();
//      if (Key >= 2) {
//        Layout = 0; //
//      }
//      if (Key == KEY_RETURN)
//      {
//        Keyboard.press(KEY_LEFT_SHIFT);
//      }
//      if ((Key >= 'a') && (Key <= 'z'))
//      {
//        Keyboard.press(KEY_LEFT_CTRL);
//      }
//      break;
//
//    case 3:
//      digitalWrite(ledaA, HIGH);
//      digitalWrite(ledFn, HIGH);
//      Key = capsLayout.getKey();
//      break;
//    default:
//      Layout = 0;
//      break;
//  }
//  if (Key == 1)
//  {
//    Layout++;
//    Key = 0;
//    delay(300); // teraz mozem mal!23!{}
//   playTone( 50, 5000); 
//  }
//
// (Key) {
//    //  Keyboard.press(ctrlKey);
//    Keyboard.press(Key);
//    delay(100);
//    playTone( 10, 10000); 
//    Keyboard.releaseAll();
//  }
//}

void playTone(long duration, int freq) {
// duration in mSecs, frequency in hertz

//  duration *= 10;
  int period = (1.0 / freq) * 1000000;
  long elapsed_time = 0;
  int amax=0;
  byte up=1;

//    while (elapsed_time < duration) {
//      analogWrite(speaker,1020);
//      delayMicroseconds(period / 2);
//      analogWrite(speaker, 0);
//      delayMicroseconds(period / 2);
//      elapsed_time += (period);  

    while (elapsed_time < duration) {

      analogWrite(speaker,amax/2);
      delayMicroseconds(period /4); 

      analogWrite(speaker,amax);
      delayMicroseconds(period /4);

      analogWrite(speaker,amax/2) ;
      delayMicroseconds(period /4);
      
      analogWrite(speaker,0);
      delayMicroseconds(period /4);

      if (up==1) {
        if (amax < 250) {
          amax=amax+5;
        }
        else
        {
          up=0;
        }
      }
      else
      {
        if (amax > 0) amax=amax-1;
        elapsed_time += (period);
      }

  }  
      digitalWrite(speaker,LOW); 
}
